Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2342 by niro, Fri Jan 3 14:57:23 2014 UTC revision 2410 by niro, Tue Jan 7 13:29:00 2014 UTC
# Line 16  INSTALLER_LIBDIR="%LIBDIR%" Line 16  INSTALLER_LIBDIR="%LIBDIR%"
16  # -> now in images.conf  # -> now in images.conf
17  CURRENTLINE=0  CURRENTLINE=0
18    
19  # configuration  die()
20  if [ -e %SYSCONFDIR%/installer.conf ]  {
21  then   echo "Error: $@"
22   source %SYSCONFDIR%/installer.conf   exit 1
23  else  }
24   die "/etc/installer.conf not found"  
25  fi  # load common includes
26    for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41  # -> now in images.conf  # -> now in images.conf
# Line 39  else Line 52  else
52   die "/mnt/cdrom/system/images.conf not found"   die "/mnt/cdrom/system/images.conf not found"
53  fi  fi
54    
 # includes  
 source ${INSTALLER_LIBDIR}/functions/hwdetection.sh  
   
55  ### System/Config Version  ### System/Config Version
56  VERSION="%VERSIONTAG%"  VERSION="%VERSIONTAG%"
57  TITLE="${DEFAULT_TITLE} - ${VERSION}"  TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  CDPATH="${DEFAULT_CDPATH}"  # some sane defaults
60    CDROOT="${DEFAULT_CDROOT}"
61  INSTALLROOT="${DEFAULT_INSTALLROOT}"  INSTALLROOT="${DEFAULT_INSTALLROOT}"
62    KERNELPKG="${DEFAULT_KERNELPKG}"
63  # standard kernel opts  KERNELOPTS="${DEFAULT_KERNELOPTS}"
 KERNELOPTS="quiet video=1024x768"  
   
 # grub options  
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
   
 # target filesystem  
69  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   echo "Error: $@"   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78     is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84   exit 1   exit 1
85  }  }
86    
# Line 86  dialog_die() Line 94  dialog_die()
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
112    
113   dialog \   dialog \
114   --colors \   --colors \
# Line 134  dialog_setup_hdd_info_flash() Line 122  dialog_setup_hdd_info_flash()
122    
123  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
124  {  {
125   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
126    
127   dialog \   dialog \
128   --colors \   --colors \
# Line 161  dialog_setup_system_menu() Line 149  dialog_setup_system_menu()
149   "" "" \   "" "" \
150   "" "\Z1Experten Modi:\Zn" \   "" "\Z1Experten Modi:\Zn" \
151   "2" "Normale IDE-Disk (Manuell)" \   "2" "Normale IDE-Disk (Manuell)" \
  "3" "Flash-Speicher (Manuell)")  
152   RES=$?   RES=$?
153   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
154   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
# Line 169  dialog_setup_system_menu() Line 156  dialog_setup_system_menu()
156   case "${i}" in   case "${i}" in
157   "1") run_install_auto ;;   "1") run_install_auto ;;
158   "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
159   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
160   esac   esac
161   fi   fi
# Line 180  dialog_hardware_detection() Line 166  dialog_hardware_detection()
166   local i   local i
167   local hwtmp   local hwtmp
168    
169   if [ -x $(which mktemp &> /dev/null) ]   if [ -x $(type -P mktemp) ]
170   then   then
171   hwtmp="$(mktemp)"   hwtmp="$(mktemp)"
172   else   else
173   hwtmp="/tmp/hwtmp.sh"   hwtmp="/tmp/hwtmp.sh"
174   fi   fi
175    
176   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
177    
178   echo "dialog \\"  > ${hwtmp}   echo "dialog \\"  > ${hwtmp}
179   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}   echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}
# Line 197  dialog_hardware_detection() Line 183  dialog_hardware_detection()
183   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}   echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}
184   echo " Festplatten:\n \\" >> ${hwtmp}   echo " Festplatten:\n \\" >> ${hwtmp}
185    
186   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
187   then   then
188   for i in ${scsidisks}   for i in ${ALL_DISKS}
189   do   do
190   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
191   done   done
192   fi   fi
193    
194   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
195   then   then
196   for i in ${idedisks}   echo " \n \\" >> ${hwtmp}
197     echo " CDROM Laufwerke:\n \\" >> ${hwtmp}
198     for i in ${ALL_CDROMS}
199   do   do
200   if [[ ${i} != ${cdromdev} ]]   echo " \\Z3${i}\\Zn\n \\" >> ${hwtmp}
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
201   done   done
202   fi   fi
203    
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
  fi  
   
204   # other devices   # other devices
205   run_hardware_detection   run_hardware_detection
206   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
# Line 290  dialog_setup_hdd_partitions_manuell() Line 263  dialog_setup_hdd_partitions_manuell()
263   fi   fi
264  }  }
265    
266  dialog_setup_hdd_partitions_manuell_flash()  dialog_setup_hdd_partitions_auto()
267  {  {
268   local i   local i
269    
# Line 322  dialog_setup_hdd_partitions_manuell_flas Line 295  dialog_setup_hdd_partitions_manuell_flas
295   [[ ${RES} -eq 1 ]] && return 1   [[ ${RES} -eq 1 ]] && return 1
296   if [[ ${RES} -eq 0 ]]   if [[ ${RES} -eq 0 ]]
297   then   then
298   dialog_setup_hdd_info_flash   dialog_setup_hdd_info_auto
299   setup_hdd_partitions_manuell_flash   dialog_setup_hdd_create_partitions
300     setup_hdd_partitions_auto
301   fi   fi
302   fi   fi
303  }  }
304    
305  dialog_setup_hdd_partitions_auto()  run_hardware_detection_disks()
306  {  {
307   local i   local bootdev
308    
309   if [[ -z ${installdevs} ]]   # all disks but exclude ramdisks
310     export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
311     # remove the boot device from ALL_DISKS if it was an usbstick
312     if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
313   then   then
314   dialog \   bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
315   --backtitle "${TITLE}" \   export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
316   fi   fi
317     export ALL_CDROMS="$(get_hwinfo cdrom)"
318  }  }
319    
320  dialog_setup_hdd_create_partitions()  dialog_setup_hdd_create_partitions()
# Line 606  EOF Line 556  EOF
556    
557  setup_hdd_partitions_manuell()  setup_hdd_partitions_manuell()
558  {  {
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || dialog_die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
 {  
559   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
560    
561   ## hdds partitionieren manuell   ## hdds partitionieren manuell
# Line 624  setup_hdd_partitions_manuell_flash() Line 564  setup_hdd_partitions_manuell_flash()
564    
565  setup_hdd_format()  setup_hdd_format()
566  {  {
  mkswap ${SWAPHDD} || dialog_die  
  mke2fs -j -q ${BOOTHDD} || dialog_die  
  mke2fs -j -q ${ROOTHDD} || dialog_die  
 }  
   
 setup_hdd_format_flash()  
 {  
567   mke2fs -j -q ${ROOTHDD} || dialog_die   mke2fs -j -q ${ROOTHDD} || dialog_die
568  }  }
569    
570  install_mount_rootfs()  install_mount_rootfs()
571  {  {
  swapon ${SWAPHDD} || dialog_die  
  mount ${ROOTHDD} ${INSTALLROOT} || dialog_die  
  install -d ${INSTALLROOT}/boot || dialog_die  
  mount ${BOOTHDD} ${INSTALLROOT}/boot || dialog_die  
  cd ${INSTALLROOT} || dialog_die  
 }  
   
 install_mount_rootfs_flash()  
 {  
572   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
573   install -d ${INSTALLROOT}/boot || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
574   cd ${INSTALLROOT} || dialog_die   cd ${INSTALLROOT} || dialog_die
# Line 652  install_mount_rootfs_flash() Line 576  install_mount_rootfs_flash()
576    
577  install_system_image()  install_system_image()
578  {  {
579   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
580  }  }
581    
582  install_bootsector_chroot()  install_bootsector_chroot()
# Line 829  CHROOTEOF Line 753  CHROOTEOF
753    
754  is_uuid_supported()  is_uuid_supported()
755  {  {
756   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
757   then   then
758   # only detect uuids if supported   # only detect uuids if supported
759   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 865  install_system_settings() Line 789  install_system_settings()
789   # schreibe fstab   # schreibe fstab
790   if is_uuid_supported   if is_uuid_supported
791   then   then
  echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
792   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
793   else   else
  echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLROOT}/etc/fstab || dialog_die  
794   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
795   fi   fi
796   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
# Line 893  install_system_settings() Line 815  install_system_settings()
815   fi   fi
816  }  }
817    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
 }  
   
818  install_umount_rootfs()  install_umount_rootfs()
819  {  {
820   cd /   cd /
821   umount ${INSTALLROOT}/boot || dialog_die   umount ${INSTALLROOT}/boot || dialog_die
822   umount ${INSTALLROOT} || dialog_die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || dialog_die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLROOT} || dialog_die  
823  }  }
824    
825  install_do_reboot()  install_do_reboot()
# Line 951  run_install_normal() Line 853  run_install_normal()
853   dialog_install_successful   dialog_install_successful
854  }  }
855    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
856  run_install_auto()  run_install_auto()
857  {  {
858   dialog_hardware_detection   dialog_hardware_detection
859    
860   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
861   dialog_setup_hdd_format   dialog_setup_hdd_format
862   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
863   install_mount_rootfs_flash   install_mount_rootfs
864   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image
865    
866   dialog_install_settings   dialog_install_settings
867   sleep 1   sleep 1
868   install_system_settings_flash   install_system_settings
869   install_initrd_chroot   install_initrd_chroot
870    
871   dialog_install_bootsector   dialog_install_bootsector
872   install_bootsector_chroot   install_bootsector_chroot
873    
874   install_umount_rootfs_flash   install_umount_rootfs
875   dialog_install_successful   dialog_install_successful
876  }  }
877    
878    # set some proper traps
879    trap "trap_exit" SIGINT SIGQUIT
880    
881  dialog_main  dialog_main
882    
883  exit 0  exit 0

Legend:
Removed from v.2342  
changed lines
  Added in v.2410